Index: trunk/src/VBox/Main/src-client/ConsoleImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 45029)
+++ trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 45030)
@@ -9811,12 +9811,12 @@
 DECLCALLBACK(void) Console::drvStatus_UnitChanged(PPDMILEDCONNECTORS pInterface, unsigned iLUN)
 {
-    PDRVMAINSTATUS pData = (PDRVMAINSTATUS)((uintptr_t)pInterface - RT_OFFSETOF(DRVMAINSTATUS, ILedConnectors));
-    if (iLUN >= pData->iFirstLUN && iLUN <= pData->iLastLUN)
+    PDRVMAINSTATUS pThis = (PDRVMAINSTATUS)((uintptr_t)pInterface - RT_OFFSETOF(DRVMAINSTATUS, ILedConnectors));
+    if (iLUN >= pThis->iFirstLUN && iLUN <= pThis->iLastLUN)
     {
         PPDMLED pLed;
-        int rc = pData->pLedPorts->pfnQueryStatusLed(pData->pLedPorts, iLUN, &pLed);
+        int rc = pThis->pLedPorts->pfnQueryStatusLed(pThis->pLedPorts, iLUN, &pLed);
         if (RT_FAILURE(rc))
             pLed = NULL;
-        ASMAtomicWritePtr(&pData->papLeds[iLUN - pData->iFirstLUN], pLed);
+        ASMAtomicWritePtr(&pThis->papLeds[iLUN - pThis->iFirstLUN], pLed);
         Log(("drvStatus_UnitChanged: iLUN=%d pLed=%p\n", iLUN, pLed));
     }
@@ -9833,15 +9833,15 @@
 DECLCALLBACK(int) Console::drvStatus_MediumEjected(PPDMIMEDIANOTIFY pInterface, unsigned uLUN)
 {
-    PDRVMAINSTATUS pData = (PDRVMAINSTATUS)((uintptr_t)pInterface - RT_OFFSETOF(DRVMAINSTATUS, IMediaNotify));
-    PPDMDRVINS pDrvIns = pData->pDrvIns;
+    PDRVMAINSTATUS pThis = (PDRVMAINSTATUS)((uintptr_t)pInterface - RT_OFFSETOF(DRVMAINSTATUS, IMediaNotify));
+    PPDMDRVINS pDrvIns = pThis->pDrvIns;
     LogFunc(("uLUN=%d\n", uLUN));
-    if (pData->pmapMediumAttachments)
-    {
-        AutoWriteLock alock(pData->pConsole COMMA_LOCKVAL_SRC_POS);
+    if (pThis->pmapMediumAttachments)
+    {
+        AutoWriteLock alock(pThis->pConsole COMMA_LOCKVAL_SRC_POS);
 
         ComPtr<IMediumAttachment> pMediumAtt;
-        Utf8Str devicePath = Utf8StrFmt("%s/LUN#%u", pData->pszDeviceInstance, uLUN);
-        Console::MediumAttachmentMap::const_iterator end = pData->pmapMediumAttachments->end();
-        Console::MediumAttachmentMap::const_iterator it = pData->pmapMediumAttachments->find(devicePath);
+        Utf8Str devicePath = Utf8StrFmt("%s/LUN#%u", pThis->pszDeviceInstance, uLUN);
+        Console::MediumAttachmentMap::const_iterator end = pThis->pmapMediumAttachments->end();
+        Console::MediumAttachmentMap::const_iterator it = pThis->pmapMediumAttachments->find(devicePath);
         if (it != end)
             pMediumAtt = it->second;
@@ -9862,13 +9862,13 @@
 
                     ComPtr<IMediumAttachment> pNewMediumAtt;
-                    rc = pData->pConsole->mControl->EjectMedium(pMediumAtt, pNewMediumAtt.asOutParam());
+                    rc = pThis->pConsole->mControl->EjectMedium(pMediumAtt, pNewMediumAtt.asOutParam());
                     if (SUCCEEDED(rc))
-                        fireMediumChangedEvent(pData->pConsole->mEventSource, pNewMediumAtt);
+                        fireMediumChangedEvent(pThis->pConsole->mEventSource, pNewMediumAtt);
 
                     alock.acquire();
                     if (pNewMediumAtt != pMediumAtt)
                     {
-                        pData->pmapMediumAttachments->erase(devicePath);
-                        pData->pmapMediumAttachments->insert(std::make_pair(devicePath, pNewMediumAtt));
+                        pThis->pmapMediumAttachments->erase(devicePath);
+                        pThis->pmapMediumAttachments->insert(std::make_pair(devicePath, pNewMediumAtt));
                     }
                 }
@@ -9903,12 +9903,12 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN_VOID(pDrvIns);
-    PDRVMAINSTATUS pData = PDMINS_2_DATA(pDrvIns, PDRVMAINSTATUS);
+    PDRVMAINSTATUS pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINSTATUS);
     LogFlowFunc(("iInstance=%d\n", pDrvIns->iInstance));
 
-    if (pData->papLeds)
-    {
-        unsigned iLed = pData->iLastLUN - pData->iFirstLUN + 1;
+    if (pThis->papLeds)
+    {
+        unsigned iLed = pThis->iLastLUN - pThis->iFirstLUN + 1;
         while (iLed-- > 0)
-            ASMAtomicWriteNullPtr(&pData->papLeds[iLed]);
+            ASMAtomicWriteNullPtr(&pThis->papLeds[iLed]);
     }
 }
@@ -9923,5 +9923,5 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN(pDrvIns);
-    PDRVMAINSTATUS pData = PDMINS_2_DATA(pDrvIns, PDRVMAINSTATUS);
+    PDRVMAINSTATUS pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINSTATUS);
     LogFlowFunc(("iInstance=%d\n", pDrvIns->iInstance));
 
@@ -9939,13 +9939,13 @@
      */
     pDrvIns->IBase.pfnQueryInterface        = Console::drvStatus_QueryInterface;
-    pData->ILedConnectors.pfnUnitChanged    = Console::drvStatus_UnitChanged;
-    pData->IMediaNotify.pfnEjected          = Console::drvStatus_MediumEjected;
-    pData->pDrvIns                          = pDrvIns;
-    pData->pszDeviceInstance                = NULL;
+    pThis->ILedConnectors.pfnUnitChanged    = Console::drvStatus_UnitChanged;
+    pThis->IMediaNotify.pfnEjected          = Console::drvStatus_MediumEjected;
+    pThis->pDrvIns                          = pDrvIns;
+    pThis->pszDeviceInstance                = NULL;
 
     /*
      * Read config.
      */
-    int rc = CFGMR3QueryPtr(pCfg, "papLeds", (void **)&pData->papLeds);
+    int rc = CFGMR3QueryPtr(pCfg, "papLeds", (void **)&pThis->papLeds);
     if (RT_FAILURE(rc))
     {
@@ -9954,5 +9954,5 @@
     }
 
-    rc = CFGMR3QueryPtrDef(pCfg, "pmapMediumAttachments", (void **)&pData->pmapMediumAttachments, NULL);
+    rc = CFGMR3QueryPtrDef(pCfg, "pmapMediumAttachments", (void **)&pThis->pmapMediumAttachments, NULL);
     if (RT_FAILURE(rc))
     {
@@ -9960,7 +9960,7 @@
         return rc;
     }
-    if (pData->pmapMediumAttachments)
-    {
-        rc = CFGMR3QueryStringAlloc(pCfg, "DeviceInstance", &pData->pszDeviceInstance);
+    if (pThis->pmapMediumAttachments)
+    {
+        rc = CFGMR3QueryStringAlloc(pCfg, "DeviceInstance", &pThis->pszDeviceInstance);
         if (RT_FAILURE(rc))
         {
@@ -9968,5 +9968,5 @@
             return rc;
         }
-        rc = CFGMR3QueryPtr(pCfg, "pConsole", (void **)&pData->pConsole);
+        rc = CFGMR3QueryPtr(pCfg, "pConsole", (void **)&pThis->pConsole);
         if (RT_FAILURE(rc))
         {
@@ -9976,7 +9976,7 @@
     }
 
-    rc = CFGMR3QueryU32(pCfg, "First", &pData->iFirstLUN);
+    rc = CFGMR3QueryU32(pCfg, "First", &pThis->iFirstLUN);
     if (rc == VERR_CFGM_VALUE_NOT_FOUND)
-        pData->iFirstLUN = 0;
+        pThis->iFirstLUN = 0;
     else if (RT_FAILURE(rc))
     {
@@ -9985,7 +9985,7 @@
     }
 
-    rc = CFGMR3QueryU32(pCfg, "Last", &pData->iLastLUN);
+    rc = CFGMR3QueryU32(pCfg, "Last", &pThis->iLastLUN);
     if (rc == VERR_CFGM_VALUE_NOT_FOUND)
-        pData->iLastLUN = 0;
+        pThis->iLastLUN = 0;
     else if (RT_FAILURE(rc))
     {
@@ -9993,7 +9993,7 @@
         return rc;
     }
-    if (pData->iFirstLUN > pData->iLastLUN)
-    {
-        AssertMsgFailed(("Configuration error: Invalid unit range %u-%u\n", pData->iFirstLUN, pData->iLastLUN));
+    if (pThis->iFirstLUN > pThis->iLastLUN)
+    {
+        AssertMsgFailed(("Configuration error: Invalid unit range %u-%u\n", pThis->iFirstLUN, pThis->iLastLUN));
         return VERR_GENERAL_FAILURE;
     }
@@ -10003,10 +10003,10 @@
      * query the LEDs we want.
      */
-    pData->pLedPorts = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMILEDPORTS);
-    AssertMsgReturn(pData->pLedPorts, ("Configuration error: No led ports interface above!\n"),
+    pThis->pLedPorts = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMILEDPORTS);
+    AssertMsgReturn(pThis->pLedPorts, ("Configuration error: No led ports interface above!\n"),
                     VERR_PDM_MISSING_INTERFACE_ABOVE);
 
-    for (unsigned i = pData->iFirstLUN; i <= pData->iLastLUN; ++i)
-        Console::drvStatus_UnitChanged(&pData->ILedConnectors, i);
+    for (unsigned i = pThis->iFirstLUN; i <= pThis->iLastLUN; ++i)
+        Console::drvStatus_UnitChanged(&pThis->ILedConnectors, i);
 
     return VINF_SUCCESS;
Index: trunk/src/VBox/Main/src-client/DisplayImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/DisplayImpl.cpp	(revision 45029)
+++ trunk/src/VBox/Main/src-client/DisplayImpl.cpp	(revision 45030)
@@ -4266,20 +4266,20 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN_VOID(pDrvIns);
-    PDRVMAINDISPLAY pData = PDMINS_2_DATA(pDrvIns, PDRVMAINDISPLAY);
+    PDRVMAINDISPLAY pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINDISPLAY);
     LogRelFlowFunc(("iInstance=%d\n", pDrvIns->iInstance));
 
-    if (pData->pDisplay)
-    {
-        AutoWriteLock displayLock(pData->pDisplay COMMA_LOCKVAL_SRC_POS);
+    if (pThis->pDisplay)
+    {
+        AutoWriteLock displayLock(pThis->pDisplay COMMA_LOCKVAL_SRC_POS);
 #ifdef VBOX_WITH_CRHGSMI
-        pData->pDisplay->destructCrHgsmiData();
+        pThis->pDisplay->destructCrHgsmiData();
 #endif
-        pData->pDisplay->mpDrv = NULL;
-        pData->pDisplay->mpVMMDev = NULL;
-        pData->pDisplay->mLastAddress = NULL;
-        pData->pDisplay->mLastBytesPerLine = 0;
-        pData->pDisplay->mLastBitsPerPixel = 0,
-        pData->pDisplay->mLastWidth = 0;
-        pData->pDisplay->mLastHeight = 0;
+        pThis->pDisplay->mpDrv = NULL;
+        pThis->pDisplay->mpVMMDev = NULL;
+        pThis->pDisplay->mLastAddress = NULL;
+        pThis->pDisplay->mLastBytesPerLine = 0;
+        pThis->pDisplay->mLastBitsPerPixel = 0,
+        pThis->pDisplay->mLastWidth = 0;
+        pThis->pDisplay->mLastHeight = 0;
     }
 }
@@ -4294,5 +4294,5 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN(pDrvIns);
-    PDRVMAINDISPLAY pData = PDMINS_2_DATA(pDrvIns, PDRVMAINDISPLAY);
+    PDRVMAINDISPLAY pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINDISPLAY);
     LogRelFlowFunc(("iInstance=%d\n", pDrvIns->iInstance));
 
@@ -4311,26 +4311,26 @@
     pDrvIns->IBase.pfnQueryInterface        = Display::drvQueryInterface;
 
-    pData->IConnector.pfnResize             = Display::displayResizeCallback;
-    pData->IConnector.pfnUpdateRect         = Display::displayUpdateCallback;
-    pData->IConnector.pfnRefresh            = Display::displayRefreshCallback;
-    pData->IConnector.pfnReset              = Display::displayResetCallback;
-    pData->IConnector.pfnLFBModeChange      = Display::displayLFBModeChangeCallback;
-    pData->IConnector.pfnProcessAdapterData = Display::displayProcessAdapterDataCallback;
-    pData->IConnector.pfnProcessDisplayData = Display::displayProcessDisplayDataCallback;
+    pThis->IConnector.pfnResize             = Display::displayResizeCallback;
+    pThis->IConnector.pfnUpdateRect         = Display::displayUpdateCallback;
+    pThis->IConnector.pfnRefresh            = Display::displayRefreshCallback;
+    pThis->IConnector.pfnReset              = Display::displayResetCallback;
+    pThis->IConnector.pfnLFBModeChange      = Display::displayLFBModeChangeCallback;
+    pThis->IConnector.pfnProcessAdapterData = Display::displayProcessAdapterDataCallback;
+    pThis->IConnector.pfnProcessDisplayData = Display::displayProcessDisplayDataCallback;
 #ifdef VBOX_WITH_VIDEOHWACCEL
-    pData->IConnector.pfnVHWACommandProcess = Display::displayVHWACommandProcess;
+    pThis->IConnector.pfnVHWACommandProcess = Display::displayVHWACommandProcess;
 #endif
 #ifdef VBOX_WITH_CRHGSMI
-    pData->IConnector.pfnCrHgsmiCommandProcess = Display::displayCrHgsmiCommandProcess;
-    pData->IConnector.pfnCrHgsmiControlProcess = Display::displayCrHgsmiControlProcess;
+    pThis->IConnector.pfnCrHgsmiCommandProcess = Display::displayCrHgsmiCommandProcess;
+    pThis->IConnector.pfnCrHgsmiControlProcess = Display::displayCrHgsmiControlProcess;
 #endif
 #ifdef VBOX_WITH_HGSMI
-    pData->IConnector.pfnVBVAEnable         = Display::displayVBVAEnable;
-    pData->IConnector.pfnVBVADisable        = Display::displayVBVADisable;
-    pData->IConnector.pfnVBVAUpdateBegin    = Display::displayVBVAUpdateBegin;
-    pData->IConnector.pfnVBVAUpdateProcess  = Display::displayVBVAUpdateProcess;
-    pData->IConnector.pfnVBVAUpdateEnd      = Display::displayVBVAUpdateEnd;
-    pData->IConnector.pfnVBVAResize         = Display::displayVBVAResize;
-    pData->IConnector.pfnVBVAMousePointerShape = Display::displayVBVAMousePointerShape;
+    pThis->IConnector.pfnVBVAEnable         = Display::displayVBVAEnable;
+    pThis->IConnector.pfnVBVADisable        = Display::displayVBVADisable;
+    pThis->IConnector.pfnVBVAUpdateBegin    = Display::displayVBVAUpdateBegin;
+    pThis->IConnector.pfnVBVAUpdateProcess  = Display::displayVBVAUpdateProcess;
+    pThis->IConnector.pfnVBVAUpdateEnd      = Display::displayVBVAUpdateEnd;
+    pThis->IConnector.pfnVBVAResize         = Display::displayVBVAResize;
+    pThis->IConnector.pfnVBVAMousePointerShape = Display::displayVBVAMousePointerShape;
 #endif
 
@@ -4338,6 +4338,6 @@
      * Get the IDisplayPort interface of the above driver/device.
      */
-    pData->pUpPort = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMIDISPLAYPORT);
-    if (!pData->pUpPort)
+    pThis->pUpPort = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMIDISPLAYPORT);
+    if (!pThis->pUpPort)
     {
         AssertMsgFailed(("Configuration error: No display port interface above!\n"));
@@ -4345,6 +4345,6 @@
     }
 #if defined(VBOX_WITH_VIDEOHWACCEL) || defined(VBOX_WITH_CRHGSMI)
-    pData->pVBVACallbacks = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMIDISPLAYVBVACALLBACKS);
-    if (!pData->pVBVACallbacks)
+    pThis->pVBVACallbacks = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMIDISPLAYVBVACALLBACKS);
+    if (!pThis->pVBVACallbacks)
     {
         AssertMsgFailed(("Configuration error: No VBVA callback interface above!\n"));
@@ -4362,19 +4362,19 @@
         return rc;
     }
-    pData->pDisplay = (Display *)pv;        /** @todo Check this cast! */
-    pData->pDisplay->mpDrv = pData;
+    pThis->pDisplay = (Display *)pv;        /** @todo Check this cast! */
+    pThis->pDisplay->mpDrv = pThis;
 
     /*
      * Update our display information according to the framebuffer
      */
-    pData->pDisplay->updateDisplayData();
+    pThis->pDisplay->updateDisplayData();
 
     /*
      * Start periodic screen refreshes
      */
-    pData->pUpPort->pfnSetRefreshRate(pData->pUpPort, 20);
+    pThis->pUpPort->pfnSetRefreshRate(pThis->pUpPort, 20);
 
 #ifdef VBOX_WITH_CRHGSMI
-    pData->pDisplay->setupCrHgsmiData();
+    pThis->pDisplay->setupCrHgsmiData();
 #endif
 
Index: trunk/src/VBox/Main/src-client/KeyboardImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/KeyboardImpl.cpp	(revision 45029)
+++ trunk/src/VBox/Main/src-client/KeyboardImpl.cpp	(revision 45030)
@@ -316,17 +316,17 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN_VOID(pDrvIns);
-    PDRVMAINKEYBOARD pData = PDMINS_2_DATA(pDrvIns, PDRVMAINKEYBOARD);
+    PDRVMAINKEYBOARD pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINKEYBOARD);
     LogFlow(("Keyboard::drvDestruct: iInstance=%d\n", pDrvIns->iInstance));
 
-    if (pData->pKeyboard)
-    {
-        AutoWriteLock kbdLock(pData->pKeyboard COMMA_LOCKVAL_SRC_POS);
+    if (pThis->pKeyboard)
+    {
+        AutoWriteLock kbdLock(pThis->pKeyboard COMMA_LOCKVAL_SRC_POS);
         for (unsigned cDev = 0; cDev < KEYBOARD_MAX_DEVICES; ++cDev)
-            if (pData->pKeyboard->mpDrv[cDev] == pData)
+            if (pThis->pKeyboard->mpDrv[cDev] == pThis)
             {
-                pData->pKeyboard->mpDrv[cDev] = NULL;
+                pThis->pKeyboard->mpDrv[cDev] = NULL;
                 break;
             }
-        pData->pKeyboard->mpVMMDev = NULL;
+        pThis->pKeyboard->mpVMMDev = NULL;
     }
 }
@@ -340,5 +340,5 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN(pDrvIns);
-    PDRVMAINKEYBOARD pData = PDMINS_2_DATA(pDrvIns, PDRVMAINKEYBOARD);
+    PDRVMAINKEYBOARD pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINKEYBOARD);
     LogFlow(("Keyboard::drvConstruct: iInstance=%d\n", pDrvIns->iInstance));
 
@@ -357,12 +357,12 @@
     pDrvIns->IBase.pfnQueryInterface        = Keyboard::drvQueryInterface;
 
-    pData->IConnector.pfnLedStatusChange    = keyboardLedStatusChange;
-    pData->IConnector.pfnSetActive          = Keyboard::keyboardSetActive;
+    pThis->IConnector.pfnLedStatusChange    = keyboardLedStatusChange;
+    pThis->IConnector.pfnSetActive          = Keyboard::keyboardSetActive;
 
     /*
      * Get the IKeyboardPort interface of the above driver/device.
      */
-    pData->pUpPort = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMIKEYBOARDPORT);
-    if (!pData->pUpPort)
+    pThis->pUpPort = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMIKEYBOARDPORT);
+    if (!pThis->pUpPort)
     {
         AssertMsgFailed(("Configuration error: No keyboard port interface above!\n"));
@@ -380,10 +380,10 @@
         return rc;
     }
-    pData->pKeyboard = (Keyboard *)pv;        /** @todo Check this cast! */
+    pThis->pKeyboard = (Keyboard *)pv;        /** @todo Check this cast! */
     unsigned cDev;
     for (cDev = 0; cDev < KEYBOARD_MAX_DEVICES; ++cDev)
-        if (!pData->pKeyboard->mpDrv[cDev])
+        if (!pThis->pKeyboard->mpDrv[cDev])
         {
-            pData->pKeyboard->mpDrv[cDev] = pData;
+            pThis->pKeyboard->mpDrv[cDev] = pThis;
             break;
         }
Index: trunk/src/VBox/Main/src-client/MouseImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/MouseImpl.cpp	(revision 45029)
+++ trunk/src/VBox/Main/src-client/MouseImpl.cpp	(revision 45030)
@@ -714,14 +714,14 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN_VOID(pDrvIns);
-    PDRVMAINMOUSE pData = PDMINS_2_DATA(pDrvIns, PDRVMAINMOUSE);
+    PDRVMAINMOUSE pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINMOUSE);
     LogFlow(("Mouse::drvDestruct: iInstance=%d\n", pDrvIns->iInstance));
 
-    if (pData->pMouse)
-    {
-        AutoWriteLock mouseLock(pData->pMouse COMMA_LOCKVAL_SRC_POS);
+    if (pThis->pMouse)
+    {
+        AutoWriteLock mouseLock(pThis->pMouse COMMA_LOCKVAL_SRC_POS);
         for (unsigned cDev = 0; cDev < MOUSE_MAX_DEVICES; ++cDev)
-            if (pData->pMouse->mpDrv[cDev] == pData)
+            if (pThis->pMouse->mpDrv[cDev] == pThis)
             {
-                pData->pMouse->mpDrv[cDev] = NULL;
+                pThis->pMouse->mpDrv[cDev] = NULL;
                 break;
             }
@@ -738,5 +738,5 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN(pDrvIns);
-    PDRVMAINMOUSE pData = PDMINS_2_DATA(pDrvIns, PDRVMAINMOUSE);
+    PDRVMAINMOUSE pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINMOUSE);
     LogFlow(("drvMainMouse_Construct: iInstance=%d\n", pDrvIns->iInstance));
 
@@ -755,11 +755,11 @@
     pDrvIns->IBase.pfnQueryInterface        = Mouse::drvQueryInterface;
 
-    pData->IConnector.pfnReportModes        = Mouse::mouseReportModes;
+    pThis->IConnector.pfnReportModes        = Mouse::mouseReportModes;
 
     /*
      * Get the IMousePort interface of the above driver/device.
      */
-    pData->pUpPort = (PPDMIMOUSEPORT)pDrvIns->pUpBase->pfnQueryInterface(pDrvIns->pUpBase, PDMIMOUSEPORT_IID);
-    if (!pData->pUpPort)
+    pThis->pUpPort = (PPDMIMOUSEPORT)pDrvIns->pUpBase->pfnQueryInterface(pDrvIns->pUpBase, PDMIMOUSEPORT_IID);
+    if (!pThis->pUpPort)
     {
         AssertMsgFailed(("Configuration error: No mouse port interface above!\n"));
@@ -777,13 +777,13 @@
         return rc;
     }
-    pData->pMouse = (Mouse *)pv;        /** @todo Check this cast! */
+    pThis->pMouse = (Mouse *)pv;        /** @todo Check this cast! */
     unsigned cDev;
     {
-        AutoReadLock mouseLock(pData->pMouse COMMA_LOCKVAL_SRC_POS);
+        AutoReadLock mouseLock(pThis->pMouse COMMA_LOCKVAL_SRC_POS);
 
         for (cDev = 0; cDev < MOUSE_MAX_DEVICES; ++cDev)
-            if (!pData->pMouse->mpDrv[cDev])
+            if (!pThis->pMouse->mpDrv[cDev])
             {
-                pData->pMouse->mpDrv[cDev] = pData;
+                pThis->pMouse->mpDrv[cDev] = pThis;
                 break;
             }
Index: trunk/src/VBox/Main/src-client/PCIRawDevImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/PCIRawDevImpl.cpp	(revision 45029)
+++ trunk/src/VBox/Main/src-client/PCIRawDevImpl.cpp	(revision 45030)
@@ -119,8 +119,8 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN_VOID(pDrvIns);
-    PDRVMAINPCIRAWDEV pData = PDMINS_2_DATA(pDrvIns, PDRVMAINPCIRAWDEV);
-
-    if (pData->pPCIRawDev)
-        pData->pPCIRawDev->mpDrv = NULL;
+    PDRVMAINPCIRAWDEV pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINPCIRAWDEV);
+
+    if (pThis->pPCIRawDev)
+        pThis->pPCIRawDev->mpDrv = NULL;
 }
 
@@ -132,5 +132,5 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN(pDrvIns);
-    PDRVMAINPCIRAWDEV pData = PDMINS_2_DATA(pDrvIns, PDRVMAINPCIRAWDEV);
+    PDRVMAINPCIRAWDEV pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINPCIRAWDEV);
 
     /*
@@ -152,5 +152,5 @@
      * IConnector.
      */
-    pData->IConnector.pfnDeviceConstructComplete = PCIRawDev::drvDeviceConstructComplete;
+    pThis->IConnector.pfnDeviceConstructComplete = PCIRawDev::drvDeviceConstructComplete;
 
     /*
@@ -165,6 +165,6 @@
     }
 
-    pData->pPCIRawDev = (PCIRawDev *)pv;
-    pData->pPCIRawDev->mpDrv = pData;
+    pThis->pPCIRawDev = (PCIRawDev *)pv;
+    pThis->pPCIRawDev->mpDrv = pThis;
 
     return VINF_SUCCESS;
Index: trunk/src/VBox/Main/src-client/VMMDevInterface.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/VMMDevInterface.cpp	(revision 45029)
+++ trunk/src/VBox/Main/src-client/VMMDevInterface.cpp	(revision 45030)
@@ -762,5 +762,5 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN_VOID(pDrvIns);
-    PDRVMAINVMMDEV pData = PDMINS_2_DATA(pDrvIns, PDRVMAINVMMDEV);
+    PDRVMAINVMMDEV pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINVMMDEV);
     LogFlow(("VMMDev::drvDestruct: iInstance=%d\n", pDrvIns->iInstance));
 
@@ -768,6 +768,6 @@
     /* HGCM is shut down on the VMMDev destructor. */
 #endif /* VBOX_WITH_HGCM */
-    if (pData->pVMMDev)
-        pData->pVMMDev->mpDrv = NULL;
+    if (pThis->pVMMDev)
+        pThis->pVMMDev->mpDrv = NULL;
 }
 
@@ -778,5 +778,5 @@
 {
     PDMDRV_CHECK_VERSIONS_RETURN(pDrvIns);
-    PDRVMAINVMMDEV pData = PDMINS_2_DATA(pDrvIns, PDRVMAINVMMDEV);
+    PDRVMAINVMMDEV pThis = PDMINS_2_DATA(pDrvIns, PDRVMAINVMMDEV);
     LogFlow(("Keyboard::drvConstruct: iInstance=%d\n", pDrvIns->iInstance));
 
@@ -795,26 +795,26 @@
     pDrvIns->IBase.pfnQueryInterface                  = VMMDev::drvQueryInterface;
 
-    pData->Connector.pfnUpdateGuestStatus             = vmmdevUpdateGuestStatus;
-    pData->Connector.pfnUpdateGuestInfo               = vmmdevUpdateGuestInfo;
-    pData->Connector.pfnUpdateGuestInfo2              = vmmdevUpdateGuestInfo2;
-    pData->Connector.pfnUpdateGuestCapabilities       = vmmdevUpdateGuestCapabilities;
-    pData->Connector.pfnUpdateMouseCapabilities       = vmmdevUpdateMouseCapabilities;
-    pData->Connector.pfnUpdatePointerShape            = vmmdevUpdatePointerShape;
-    pData->Connector.pfnVideoAccelEnable              = iface_VideoAccelEnable;
-    pData->Connector.pfnVideoAccelFlush               = iface_VideoAccelFlush;
-    pData->Connector.pfnVideoModeSupported            = vmmdevVideoModeSupported;
-    pData->Connector.pfnGetHeightReduction            = vmmdevGetHeightReduction;
-    pData->Connector.pfnSetCredentialsJudgementResult = vmmdevSetCredentialsJudgementResult;
-    pData->Connector.pfnSetVisibleRegion              = vmmdevSetVisibleRegion;
-    pData->Connector.pfnQueryVisibleRegion            = vmmdevQueryVisibleRegion;
-    pData->Connector.pfnReportStatistics              = vmmdevReportStatistics;
-    pData->Connector.pfnQueryStatisticsInterval       = vmmdevQueryStatisticsInterval;
-    pData->Connector.pfnQueryBalloonSize              = vmmdevQueryBalloonSize;
-    pData->Connector.pfnIsPageFusionEnabled           = vmmdevIsPageFusionEnabled;
-
-#ifdef VBOX_WITH_HGCM
-    pData->HGCMConnector.pfnConnect                   = iface_hgcmConnect;
-    pData->HGCMConnector.pfnDisconnect                = iface_hgcmDisconnect;
-    pData->HGCMConnector.pfnCall                      = iface_hgcmCall;
+    pThis->Connector.pfnUpdateGuestStatus             = vmmdevUpdateGuestStatus;
+    pThis->Connector.pfnUpdateGuestInfo               = vmmdevUpdateGuestInfo;
+    pThis->Connector.pfnUpdateGuestInfo2              = vmmdevUpdateGuestInfo2;
+    pThis->Connector.pfnUpdateGuestCapabilities       = vmmdevUpdateGuestCapabilities;
+    pThis->Connector.pfnUpdateMouseCapabilities       = vmmdevUpdateMouseCapabilities;
+    pThis->Connector.pfnUpdatePointerShape            = vmmdevUpdatePointerShape;
+    pThis->Connector.pfnVideoAccelEnable              = iface_VideoAccelEnable;
+    pThis->Connector.pfnVideoAccelFlush               = iface_VideoAccelFlush;
+    pThis->Connector.pfnVideoModeSupported            = vmmdevVideoModeSupported;
+    pThis->Connector.pfnGetHeightReduction            = vmmdevGetHeightReduction;
+    pThis->Connector.pfnSetCredentialsJudgementResult = vmmdevSetCredentialsJudgementResult;
+    pThis->Connector.pfnSetVisibleRegion              = vmmdevSetVisibleRegion;
+    pThis->Connector.pfnQueryVisibleRegion            = vmmdevQueryVisibleRegion;
+    pThis->Connector.pfnReportStatistics              = vmmdevReportStatistics;
+    pThis->Connector.pfnQueryStatisticsInterval       = vmmdevQueryStatisticsInterval;
+    pThis->Connector.pfnQueryBalloonSize              = vmmdevQueryBalloonSize;
+    pThis->Connector.pfnIsPageFusionEnabled           = vmmdevIsPageFusionEnabled;
+
+#ifdef VBOX_WITH_HGCM
+    pThis->HGCMConnector.pfnConnect                   = iface_hgcmConnect;
+    pThis->HGCMConnector.pfnDisconnect                = iface_hgcmDisconnect;
+    pThis->HGCMConnector.pfnCall                      = iface_hgcmCall;
 #endif
 
@@ -822,10 +822,10 @@
      * Get the IVMMDevPort interface of the above driver/device.
      */
-    pData->pUpPort = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMIVMMDEVPORT);
-    AssertMsgReturn(pData->pUpPort, ("Configuration error: No VMMDev port interface above!\n"), VERR_PDM_MISSING_INTERFACE_ABOVE);
-
-#ifdef VBOX_WITH_HGCM
-    pData->pHGCMPort = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMIHGCMPORT);
-    AssertMsgReturn(pData->pHGCMPort, ("Configuration error: No HGCM port interface above!\n"), VERR_PDM_MISSING_INTERFACE_ABOVE);
+    pThis->pUpPort = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMIVMMDEVPORT);
+    AssertMsgReturn(pThis->pUpPort, ("Configuration error: No VMMDev port interface above!\n"), VERR_PDM_MISSING_INTERFACE_ABOVE);
+
+#ifdef VBOX_WITH_HGCM
+    pThis->pHGCMPort = PDMIBASE_QUERY_INTERFACE(pDrvIns->pUpBase, PDMIHGCMPORT);
+    AssertMsgReturn(pThis->pHGCMPort, ("Configuration error: No HGCM port interface above!\n"), VERR_PDM_MISSING_INTERFACE_ABOVE);
 #endif
 
@@ -841,11 +841,11 @@
     }
 
-    pData->pVMMDev = (VMMDev*)pv;        /** @todo Check this cast! */
-    pData->pVMMDev->mpDrv = pData;
-
-#ifdef VBOX_WITH_HGCM
-    rc = pData->pVMMDev->hgcmLoadService(VBOXSHAREDFOLDERS_DLL,
+    pThis->pVMMDev = (VMMDev*)pv;        /** @todo Check this cast! */
+    pThis->pVMMDev->mpDrv = pThis;
+
+#ifdef VBOX_WITH_HGCM
+    rc = pThis->pVMMDev->hgcmLoadService(VBOXSHAREDFOLDERS_DLL,
                                          "VBoxSharedFolders");
-    pData->pVMMDev->fSharedFolderActive = RT_SUCCESS(rc);
+    pThis->pVMMDev->fSharedFolderActive = RT_SUCCESS(rc);
     if (RT_SUCCESS(rc))
     {